%
% The 2 bar system in compression as described in :
% BAGUET S. and COCHELIN B. "On the behaviour of the ANM continuation in the presence of bifurcation"
% Communication in Numerical Method in Engineering, Vol 19, 459-471, 2003
% 
% u and v are the displacements of the loaded point
% lambda is the load parameter
%
%  governing equation:
%
%  (-4u + u^2 + v^2)(u-2) = lambda
%   (2 -4u + u^2 + v^2) v = 0

%   unknowns   U= [ u v lambda]
close all
clear all
ninc=3;                           
Diamanlab('sys'     ,BARRES(ninc), ...
          'order'   ,20, ...
          'U0value' , [ 0 0.001  0 ]' , ...
          'displayvariables',[ 1, 3 , 2 , 3]);      % DiaMANLAB run  
                         
