% from
%     Doedel, Keller, Kernevez (1991). 
%     Numerical analysis and control of bifurcation. 
%     Bifurcation and Chaos 1, 493-520.
%
%     Governing equations
%
%     2u1 - u2 + 100u1/(1+u1+u1*u1) = lambda 
%     2u2 - u1 + 100u2/(1+u2+u2*u2) = lambda+mu
%
%     Unknowns U = [ u1 u2 lambda ]  mu : fixed parameter

close all
clear all
mu=0.1;

Diamanlab('sys'            ,ECrea(mu) , ...      
         'U0value'         ,[ 0 0 0 ]' , ...
         'displayvariables',[3 1; 3 2]);     % DiaMANLAB run


