classdef BVPCOLLO < Syst
    properties
      Nz;
      Nmu;
      Nbc;
      Nelmt;
      Npoly;
      P;
      Pprime;
      Ppostp;
    end
    
    methods
        function sys=BVPCOLLO( Nz,Nmu,Nbc,Nelmt,Npoly,ninc )
        

        sys = sys@Syst('ninc',ninc); 

        sys.Nz    =Nz;
        sys.Nmu   =Nmu;
        sys.Nbc   =Nbc;
        sys.Nelmt =Nelmt;
        sys.Npoly =Npoly;
        sys.ninc  =ninc;

    if Npoly==3
    %Gauss points
    x=[(1-sqrt(3/5))/2 1/2 (1+sqrt(3/5))/2];
    %Interpolation function for P 
    L0=(x-1/3).*(x-2/3).*(x-1)./(-2/9);
    L1=x.*(x-2/3).*(x-1)./ (2/27);
    L2=x.*(x-1/3).*(x-1)./ (-2/27);
    L3=x.*(x-1/3).*(x-2/3)./ (2/9);
    sys.P=[L0; L1; L2; L3]';

    %interpolation function for Pprime
    L0prime=((x-1/3).*(x-2/3)+(x-1/3).*(x-1)+(x-2/3).*(x-1))./ (-2/9);
    L1prime=(x.*(x-2/3)+x.*(x-1)+(x-2/3).*(x-1))./ (2/27);
    L2prime=(x.*(x-1/3)+x.*(x-1)+(x-1/3).*(x-1))./ (-2/27);
    L3prime=(x.*(x-1/3)+x.*(x-2/3)+(x-1/3).*(x-2/3))./ (2/9);

    sys.Pprime=Nelmt*[L0prime;L1prime;L2prime;L3prime]';

    % for post-processing, with 11 points by element
    x=[ 0:0.1:1];
    L0=(x-1/3).*(x-2/3).*(x-1)./(-2/9);
    L1=x.*(x-2/3).*(x-1)./ (2/27);
    L2=x.*(x-1/3).*(x-1)./ (-2/27);
    L3=x.*(x-1/3).*(x-2/3)./ (2/9);
    sys.Ppostp=[L0; L1; L2; L3]';
   else
     stop
   end

        end 
   end        

end     
