function [ obj ] = forwardcontinuation( obj, sys, params, nbforward )
%   performs nbforwrd continuation steps, creating nbforward CheckPoint object

U0now=obj.CurPoint.U0now ;     % get the ''current point'' of the diagram object
Utnow=obj.CurPoint.Utnow  ;  
Status=obj.CurPoint.Status ;     

for i=1:nbforward    

    if get(sys,'NRmethod') == 1           
        U0now = NRcorrection(sys,U0now); 
    end
    switch Status 
        case 'regular'           
            [U0,Amax,DataBif]    = ANMseries(sys,U0now,Utnow)  ;    %  U0 (Taylor type)  

        case 'simplebif'            
            [U0,Amax,DataBif]    = ANMserieBif(sys,U0now,Utnow,obj.CurPoint.Ut2);  
    end
    
    ChckPoint      = CheckPoint(U0,Utnow,Amax,params,DataBif);
    
    disp(['Section ' num2str(i) ': ||R(U(a=0))||=' num2str(norm(R(sys,U0now)))  ...
    '||R(U(a=Amax))||=' num2str(norm(R(sys,ChckPoint.Uend))) ';  Amax=' num2str(Amax)]);
    
    disp(ChckPoint);
    
    obj=CheckPointAdd(obj,ChckPoint);
    if params.userdisplay ==1  
        figure(3);  disp(sys, ChckPoint.Uend ); drawnow;
    end
    U0now=ChckPoint.Uend;
    Utnow=ChckPoint.Utend;
    Status='regular';
end
obj.CurPoint.U0now=U0now;   % set the last end point  in the ''current point''
obj.CurPoint.Utnow=Utnow;
obj.CurPoint.Status='regular';

