function Ut = tangentvector(sys,U0,dRdU)
% Computation of the tangent vector at U0 using the Jacobian matrix dRdU at U0
% dRdU is augmented with a random vector
ninc = sys.ninc;
b = sparse(ninc,1,1,ninc,1);

% Tangent matrix
Tmat = [dRdU ; sparse(sys.randvect) ];

% Fast LU-factorization
[LT,UT,pT,qT] = lu(Tmat,'vector');
% Efficient LU-inversion
Ut(qT,1) = -  UT\(LT\b(pT));

% Normalization according to pseduo arc-length equation :
%    a=(U-Uo)*U1 + (l-lo)*l1
Ut = Ut *  1/sqrt((sys.arclengthdef.*Ut)'*Ut );

