function  Diamanlab(varargin)
% DIAMANLAB MATLAB code for Diamanlab.fig
%      DIAMANLAB, by itself, creates a new DIAMANLAB or raises the existing
%      singleton*.
%
%      H = DIAMANLAB returns the handle to a new DIAMANLAB or the handle to
%      the existing singleton*.
%
%      DIAMANLAB('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DIAMANLAB.M with the given input arguments.
%
%      DIAMANLAB('Property','Value',...) creates a new DIAMANLAB or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before diamanlab_openingfcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to diamanlab_openingfcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Diamanlab

% Last Modified by GUIDE v2.5 27-Jan-2013 15:51:29

% Begin initialization code - DO NOT EDIT

fprintf('\n');
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Diamanlab_OpeningFcn, ...
                   'gui_OutputFcn',  @Diamanlab_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before Diamanlab is made visible.
function Diamanlab_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Diamanlab (see VARARGIN)

 
propertyArgin = varargin;
while length(propertyArgin) >=2
    prop = propertyArgin{1};
    val=propertyArgin{2};
    propertyArgin=propertyArgin(3:end);
    switch prop
        case 'sys'
            sys=val;
        case 'type'
            type=val;
        case 'U0value'
            U0value=val;
           [m,n]=size(U0value);
           if (n>1)
             errordlg('Dimension mismatch: U0value should be a column vector.','on');
           end
        case 'displayvariables'
            dispvars=val;
        case 'name'
            sys=set(sys,'name',val);
        case 'order'
            sys=set(sys,'order',val);
        case 'ANMthreshold'
            sys=set(sys,'ANMthreshold',val);
        case 'NRthreshold'
            sys=set(sys,'NRthreshold',val);
        case 'NRmethod'
            sys=set(sys,'NRmethod',val);
        case 'NRitemax'
            sys=set(sys,'NRitemax',val);
    end
end  

% SYSTEM
handles.sys=sys;

% CURRENT POINT
handles.U0now = NRcorrection(handles.sys,U0value);       % Perform correction on U0value if needed
handles.Utnow = tangentvector(handles.sys,handles.U0now,Jacobian(handles.sys,handles.U0now));   % now compute the tangent at U0now 
CurPoint.U0now = handles.U0now    ;        %  set U0now in the Current point
CurPoint.Utnow = handles.Utnow    ;        %  set Utnow
CurPoint.Ut2   = [ ]        ;              %  For storing a second tangent when the CurPoint is a simple bif
CurPoint.Status= 'regular'  ;              % 'regular' or 'simplebif'
handles.CurPoint=CurPoint ;
handles.CurPointInit=CurPoint ;

% DIAGRAM
handles.diagram = ContDriver(handles.CurPoint);


% PLOT PARAMETRES 
params.axisauto   = 1;
params.uaxis      = [0 1 0 1];
params.drawtype   = '-';
params.dispcolors = ['b','r','g','c','m','y','k']; 
params.nbpts      = 15;
params.dispvars   = dispvars;
handles.params=params;



% Display diagram
fig2=figure(2);
disp(handles.diagram);
handles.hcurpoint=CurPointDisp(handles.diagram,handles.params);

scrsz = get(0,'ScreenSize');
left=scrsz(3)/7;bottom=scrsz(4)/3; width=scrsz(3)*2/5; height=scrsz(4)/2;
figure('MenuBar','none','Name','Diamanlab','NumberTitle','off',...
           'visible','off');
set( fig2 , 'position' , [left bottom width height]);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Continuation management through the interface
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%     
% Data for the GUI at start
handles.nbforward    = 5;
handles.NRmethod     = get(handles.sys,'NRmethod'); 
handles.NRthreshold  = get(handles.sys,'NRthreshold');
handles.ANMthreshold = get(handles.sys,'ANMthreshold');
handles.params.activecurve  = 1;
handles.params.markers      = 1;
handles.params.lockzoom     = 0;
handles.params.userdisplay  = 0;  


%Setting the values on the UI editbox.

set(handles.EdANMthreshold,'string',num2str(handles.sys.ANMthreshold));
set(handles.EdCorretion,'string',num2str(handles.sys.NRthreshold));
set(handles.EdSection,'string',handles.nbforward);
set(handles.EdJump,'string', num2str(handles.params.activecurve));

%Setting user display check box.
   if handles.params.userdisplay==0
       set(handles.CkbPoint, 'Value',0)
   else
       set(handles.CkbPoint, 'value',1)
   end
% Setting NR correction check box.  
   if handles.NRmethod==0
       set(handles.CkbCorrection, 'Value',0)
   else
       set(handles.CkbCorrection, 'value',1)
   end 
   
   % Setting curve markers check box.  
   if handles.params.markers==0
       set(handles.CkbMarkers, 'Value',0)
   else
       set(handles.CkbMarkers, 'value',1)
   end 
  

% Update handles structure
% Choose default command line output for Diamanlab
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Diamanlab wait for user response (see UIRESUME)
% uiwait(handles.Diamanlab);


% --- Outputs from this function are returned to the command line.
function varargout = Diamanlab_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function BtCancelSection_Callback(hObject, eventdata, handles)
% hObject    handle to BtCancelSection (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
            handles.diagram = CheckPointCancel(handles.diagram,'one');
            fprintf('Action. Cancel section ');
            disp(handles.diagram);
            handles.hcurpoint=CurPointDisp(handles.diagram,handles.params);     
   guidata(hObject, handles);       
% --- Executes on button press in BtCancelAll.
function BtCancelAll_Callback(hObject, eventdata, handles)
% hObject    handle to BtCancelAll (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
             handles.diagram = CheckPointCancel(handles.diagram,'all');
             fprintf('Action. Cancel the diagram');
             disp(handles.diagram);
             handles.hcurpoint=CurPointDisp(handles.diagram,handles.params);
   guidata(hObject, handles);               

% --- Executes on button press in BtLoad.
function BtLoad_Callback(hObject, eventdata, handles)
% hObject    handle to BtLoad (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
          [file,path] = uigetfile;
            if (file ~=0 && path~=0)
                loadeddatas = load('-mat',[path file],'diagram') ;
                handles.diagram = loadeddatas.diagram;
                fprintf('Action. Load  diagram');
            end
  guidata(hObject, handles);  
   
% --- Executes on button press in BtSave.
function BtSave_Callback(hObject, eventdata, handles)
% hObject    handle to BtSave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
            [file,path] = uiputfile;
            diagram = handles.diagram; 
            save([path file], 'diagram');
            fprintf('Action. Save  diagram');
  guidata(hObject, handles);  
% --- Executes on button press in BtVariables.
function BtVariables_Callback(hObject, eventdata, handles)
% hObject    handle to BtVariables (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
   handles.hcurpoint=CurPointErase( handles.diagram, handles.params, handles.hcurpoint);
   [handles.diagram,handles.params]=displayvariables(handles.diagram,handles.params);
   handles.hcurpoint= CurPointDisp( handles.diagram, handles.params);
   fprintf('Action. change display variables and redraw  '); 
   
 guidata(hObject, handles);   

% --- Executes on button press in CkbMarkers.
function CkbMarkers_Callback(hObject, eventdata, handles)
% hObject    handle to CkbMarkers (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
     handles.params.markers=mod(handles.params.markers+1,2);
            if handles.params.markers==1 
               fprintf('Action. Markers On')
            else
               fprintf('Action. Markers Off')
            end     
 guidata(hObject, handles);
      % Hint: get(hObject,'Value') returns toggle state of CkbMarkers


% --- Executes on button press in CkbZoom.
function CkbZoom_Callback(hObject, eventdata, handles)
% hObject    handle to CkbZoom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of CkbZoom


% --- Executes on button press in BtSelectPoint.
function BtSelectPoint_Callback(hObject, eventdata, handles)
% hObject    handle to BtSelectPoint (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
            fprintf('Action: User display visualisation of the selected point');
            handles.U = visupoint(handles.diagram,handles.params);
            figure(3);  disp(handles.sys, handles.U ); drawnow;
guidata(hObject, handles);
% --- Executes on button press in BtInitial.
function BtInitial_Callback(hObject, eventdata, handles)
% hObject    handle to BtInitial (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
            handles.hcurpoint=CurPointErase( handles.diagram, handles.params, handles.hcurpoint);
             %handles.diagram=set( handles.diagram,'U0now', handles.Uinit,'Utnow', handles.Utinit,'curPtStatut', handles.curPtStatut);
             handles.diagram.CurPoint=handles.CurPointInit;
             handles.hcurpoint= CurPointDisp( handles.diagram, handles.params);
                if  handles.params.userdisplay ==1  
                   figure(3);  disp( handles.sys, get(handles.diagram,'U0now'));  drawnow;
                end           
             fprintf('Action. replace current point to initial position');            
   guidata(hObject, handles);
% --- Executes on button press in BtSet.

function BtSet_Callback(hObject, eventdata, handles)
% hObject    handle to BtSet (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
            fprintf('Action. set the current point \n');
            figure(2);
            if length(get(handles.diagram,'ChckPoint')) == 0
                disp('Empty diagram');
            else
                handles.hcurpoint=CurPointErase(handles.diagram,handles.params,handles.hcurpoint); 
                handles.diagram=CurPointSet(handles.diagram,handles.params); 
                handles.hcurpoint=CurPointDisp(handles.diagram,handles.params);
                if handles.params.userdisplay ==1  
                   figure(3);  disp(handles.sys, get(handles.diagram,'U0now')); drawnow;
                end
            end
guidata(hObject, handles);
% --- Executes on button press in Btjump.
function Btjump_Callback(hObject, eventdata, handles)

% hObject    handle to Btjump (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
            handles.diagram=CurPointJump(handles.diagram,handles.sys,handles.params);
            handles.hcurpoint=CurPointErase(handles.diagram,handles.params,handles.hcurpoint);
            fprintf('Action: Jump to the selected point');
            handles.hcurpoint=CurPointDisp(handles.diagram,handles.params);
            if handles.params.userdisplay ==1  
               figure(3);  disp(handles.sys, get(handles.diagram,'U0now')); drawnow;
             end
    guidata(hObject, handles); 

% --- Executes on button press in BtInvTangent.
function BtInvTangent_Callback(hObject, eventdata, handles)
% hObject    handle to BtInvTangent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
            handles.hcurpoint=CurPointErase(handles.diagram,handles.params,handles.hcurpoint); 
            handles.diagram=CurPointInvTan(handles.diagram);
            fprintf('Action. Invert tangent vector')
            handles.hcurpoint=CurPointDisp(handles.diagram,handles.params); 
    guidata(hObject, handles);

function EdSection_Callback(hObject, eventdata, handles)
% hObject    handle to EdSection (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of EdSection as text
%        str2double(get(hObject,'String')) returns contents of EdSection as a double
    handles.nbforward=str2num(get(handles.EdSection,'String'));
    fprintf('Action: Number of forward computations updated to %i ',handles.nbforward);
    guidata(hObject, handles); 

% --- Executes during object creation, after setting all properties.
function EdSection_CreateFcn(hObject, eventdata, handles)
% hObject    handle to EdSection (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in BtForward.
function BtForward_Callback(hObject, eventdata, handles)
% hObject    handle to BtForward (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

            fprintf('Action. Forward computation of %i sections \n',handles.nbforward);
            handles.hcurpoint=CurPointErase(handles.diagram,handles.params,handles.hcurpoint);  
            handles.diagram=forwardcontinuation(handles.diagram,handles.sys,handles.params,handles.nbforward);            
            handles.hcurpoint=CurPointDisp(handles.diagram,handles.params);
  
guidata(hObject, handles);


function EdANMthreshold_Callback(hObject, eventdata, handles)
% hObject    handle to EdANMthreshold (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.sys.ANMthreshold=str2double(get(handles.EdANMthreshold,'String'));
fprintf('ANM threshold is updated to %i ',handles.sys.ANMthreshold);
guidata(hObject, handles);
% Hints: get(hObject,'String') returns contents of EdANMthreshold as text
%        str2double(get(hObject,'String')) returns contents of EdANMthreshold as a double


% --- Executes during object creation, after setting all properties.
function EdANMthreshold_CreateFcn(hObject, eventdata, handles)
% hObject    handle to EdANMthreshold (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in CkbCorrection.
function CkbCorrection_Callback(hObject, eventdata, handles)
% hObject    handle to CkbCorrection (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of CkbCorrection
            handles.NRmethod=mod(handles.NRmethod+1,2);
            if handles.NRmethod==1 
                handles.sys=set(handles.sys,'NRmethod',1) ;fprintf('Action. NR corrections: On')
            else
                handles.sys=set(handles.sys,'NRmethod',0); fprintf('Action. NR corrections: Off')
            end          
guidata(hObject, handles);

function EdCorretion_Callback(hObject, eventdata, handles)


% hObject    handle to EdCorretion (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.NRthreshold = str2double(get(handles.EdCorretion,'String'));
handles.sys = set(handles.sys,'NRthreshold', handles.NRthreshold);
if (norm(R(handles.sys,handles.U0now))>handles.NRthreshold)
    handles.Unow = NRcorrection(handles.sys, handles.U0now);
    handles.diagram.U0now=handles.Unow;
end
handles.diagram.Utnow=tangentvector(handles.sys,Jacobian(handles.sys,handles.U0now));
handles.hcurpoint=CurPointErase(handles.diagram,handles.params,handles.hcurpoint);
handles.hcurpoint=CurPointDisp(handles.diagram,handles.params);

fprintf('NR threshold is updated to %i ', handles.NRthreshold);
guidata(hObject,handles);

% Hints: get(hObject,'String') returns contents of EdCorretion as text
%        str2double(get(hObject,'String')) returns contents of EdCorretion as a double


% --- Executes during object creation, after setting all properties.
function EdCorretion_CreateFcn(hObject, eventdata, handles)
% hObject    handle to EdCorretion (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in BtExit.
function BtExit_Callback(hObject, eventdata, handles)
% hObject    handle to BtExit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
confirm=  questdlg('Are you sure to close Diamanlab?','Close Diamanlab ?','Yes','No','No');
if strcmp(confirm,'Yes')
    for i=get(0,'Children')'
        if i~=handles.Diamanlab
            close(i);
        end       
    end
    delete(handles.Diamanlab);
    clear all;
    clc    
end


% --- Executes on button press in CkbPoint.
function CkbPoint_Callback(hObject, eventdata, handles)
% hObject    handle to CkbPoint (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
           if get(handles.CkbPoint,'value')==1
                 
                handles.params.userdisplay = 1;
                fprintf('Action. point display on'); 
            else
                handles.params.userdisplay = 0;
                fprintf('Action. point display off'); 
           end            
             
guidata(hObject, handles);
% Hint: get(hObject,'Value') returns toggle state of CkbPoint

% --- Executes on mouse press over figure background.
function Diamanlab_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to Diamanlab (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function EdJump_Callback(hObject, eventdata, handles)
% hObject    handle to EdJump (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 handles.params.activecurve=str2double(get(handles.EdJump,'String'));
            
            if (handles.params.activecurve <= length(handles.params.dispvars(:,1)))
                fprintf('Action: Active curve updated:  %i ',handles.params.activecurve);  
            else
                fprintf('Action: Provided number g.t. than the total number of curves  %i ',handles.params.activecurve);  
                handles.params.activecurve=1;
            end
guidata(hObject, handles);
% Hints: get(hObject,'String') returns contents of EdJump as text
%        str2double(get(hObject,'String')) returns contents of EdJump as a double


% --- Executes during object creation, after setting all properties.
function EdJump_CreateFcn(hObject, eventdata, handles)
% hObject    handle to EdJump (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
